Name:           libnfs
Version:        5.0.3
Release:        2
Summary:        A library for accessing NFS shares over a network

License:        LGPLv2+ and BSD
URL:            https://github.com/sahlberg/libnfs
Source0:        https://github.com/sahlberg/libnfs/archive/refs/tags/%{name}-%{version}.tar.gz

Patch0:         backport-Fix-out-of-bounds-reading-of-v4-READLINK-results.patch
Patch1:         backport-Avoid-explicit-memset-calls-with-calloc.patch
Patch2:         backport-libnfs-fix-memory-leak-in-nfs4_set_client_name.patch

BuildRequires: gcc pkgconfig automake libtool

%description
Package contains a library of functions for accessing NFSv2 and NFSv3 servers from user space.
It provides a low-level,asynchronous RPC library for accessing NFS protocols, an asynchronous
library with POSIX-like VFS functions,and a synchronous library with POSIX-like VFS functions.

%package devel
Summary:        Development files for libnfs
License:        LGPLv2+ and BSD and GPLv3+

Requires:       %{name} = %{version}-%{release}

%description devel
The libnfs-devel package contains libraries and header files for developing applications that use libnfs.


%package utils
Summary:        Utilities for accessing NFS servers
License:        GPLv3+

Requires:       %{name} = %{version}-%{release}

%description utils
The libnfs-utils package contains simple client programs for accessing NFS servers using libnfs.

%package help
Summary:        Help package for libnfs

%description help
Help package for libnfs

%prep
%autosetup -n %{name}-%{name}-%{version} -p1
autoreconf -vif


%build
%configure --disable-static --disable-examples --disable-werror
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build V=1

%install
%make_install
%delete_la

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%{_libdir}/libnfs.so.*
%doc COPYING LICENCE-*.txt

%files devel
%{_libdir}/libnfs.so
%{_includedir}/nfsc/
%{_libdir}/pkgconfig/libnfs.pc
%doc examples/*.c


%files utils
%{_bindir}/nfs-*

%files help
%{_mandir}/man1/nfs-*.1*
%doc README

%changelog
* Fri Aug 16 2024 zhangxingrong <zhangxingrong@uniontech.cn> - 5.0.3-2
- Fix out-of-bounds reading of v4 READLINK results
- Avoid explicit memset calls with calloc 
- libnfs: fix memory leak in nfs4_set_client_name() 

* Tue Jul 30 2024 dillon chen <dillon.chen@gmail.com> - 5.0.3-1
- upgrade to 5.0.3

* Thu Jan 25 2024 wuguanghao <wuguanghao3@huawei.com> - 5.0.2-1
- upgrade to 5.0.2:
  - fix double free in nfs3_pread_mcb()
  - Multithread support for Linux and Windows
  - fix NFS4 behavior of chmod/chown/utimes
  - Add nfs_umount() to NFSv3
  - Add nfs_statvfs64()
  - NFSv4 fix for directory handling
  - NFSv4 support
  - lockf() support(NFSv4 only)
  - fcntl() support (FNSv4 only)
  - Added nfs-fh: a simple utility to print the filehandle for a nfs file

* Thu Jan 2 2020 chenli<chenli147@huawei.com> - 1.11.0-4
- Modify spec

* Tue Dec 31 2019 chenli<chenli147@huawei.com> - 1.11.0-3
- Package init
